# README #

## Overview ##

### What is this repo?

This is biomatters' version of primer3 2.3.4, which consists of the original version plus bugfixes and improvements we've made as a result of feedback and bug reports from the Geneious Primer Design plugin. Whilst we have contributed some of our bugfixes back to the Primer3 project before, for various reasons we are currently stuck on version 2.3.4 whereas the Primer3 team usually hotfixes things into later versions of the software (such as 2.3.6). As we are not yet ready to move to a later version (it includes structural changes to the boulder io format, and we'd have to make fairly hefty changes to our Primer Design plugin), we need to maintain a repo of our own copy of 2.3.4 with these bugfixes.

### Who do I talk to? ###

Alex is responsible for this repo, talk to alex@biomatters.com

### Building it ###

This project, like the original Primer3 2.3.4, is designed to be compiled cross-platform. On linux/mac, you just need g++/gcc. On windows, it's designed to be built under the mingw environment (other environments are untested), in conjunction with mingw's win32 api libraries/headers.

## IMPORTANT CHANGES from base Primer3 2.3.4 ##

This version of Primer3 is set up to receive UTF-8 encoding for its input (on standard in). The majority of primer3's input key/value pairs are just strings consisting of latin characters (which all map to single-byte ascii code units) - and these are valid and equivalent UTF-8 encodings. However pathnames in operating systems may often have high unicode-codepoint characters in them (e.g. files in a subdirectory of a user with a Chinese username's home directory) - and Primer3 takes in a number of different paths as input (configuration files, mispriming library files, etc) which can be in these locations.

So, when you're sending input to primer3, take care that you're certain of what the encoding is, and that it's either ascii or UTF-8 (NOT UTF-16, for example).