#ifdef __WIN32__
    #include <windows.h>
    #include <stdio.h>
    #include "biomattersutils.h"

    FILE *winOpen(const char *filename, const char *mode ) {

        int val_CP_UTF8 = 65001;

        FILE *file = NULL;
        int utf16FilenameLength;
        int utf16ModeLength;
        int wideCharConversionResult = 0;
        wchar_t *utf16FilenameString = NULL;
        wchar_t *utf16ModeString = NULL;

        // get a utf-16 version of filename
        utf16FilenameLength = MultiByteToWideChar(val_CP_UTF8, 0, filename, -1, NULL, 0);
        if (utf16FilenameLength == 0) {
            goto FREE_STRINGS_AND_RETURN;
        }

        utf16FilenameString = (wchar_t*)malloc(utf16FilenameLength * sizeof(wchar_t) + sizeof(wchar_t));
        if (!utf16FilenameString) {
            goto FREE_STRINGS_AND_RETURN;
        }

        wideCharConversionResult = MultiByteToWideChar(val_CP_UTF8, 0, filename, -1, utf16FilenameString, utf16FilenameLength);
        if (wideCharConversionResult == 0) {
            goto FREE_STRINGS_AND_RETURN;
        }

        // get a utf-16 version of the open mode
        utf16ModeLength = MultiByteToWideChar(val_CP_UTF8, 0, mode, -1, NULL, 0);
        if (utf16ModeLength == 0) {
            goto FREE_STRINGS_AND_RETURN;
        }

        utf16ModeString = (wchar_t*)malloc(utf16ModeLength * sizeof(wchar_t) + sizeof(wchar_t));
        if (!utf16ModeString) {
            goto FREE_STRINGS_AND_RETURN;
        }

        wideCharConversionResult = MultiByteToWideChar(val_CP_UTF8, 0, mode, -1, utf16ModeString, utf16ModeLength);
        if (wideCharConversionResult == 0) {
            goto FREE_STRINGS_AND_RETURN;
        }

        // open the file and return the result (either a pointer to the handle, or null.
        file = _wfopen(utf16FilenameString, utf16ModeString);

        // free the memory we malloc'd and return 'file'.
        FREE_STRINGS_AND_RETURN:
        if (utf16FilenameString != NULL) {
            free(utf16FilenameString);
        }
        if (utf16ModeString != NULL) {
            free(utf16ModeString);
        }

        return file;
    }

#endif